DevExtreme v25.1 is now available.

Explore our newest features/capabilities and share your thoughts with us.

Your search did not match any results.

JavaScript/jQuery Range Slider

The JavaScript RangeSlider component allows users to choose a range of numeric values. This demo shows how you can create and configure a JavaScript RangeSlider.

DevExtreme Accessibility Compliance
DevExtreme component libraries meet a variety of WCAG and Section 508 compliance standards. To assess this demo's accessibility level, click the Run AXE® Validation button to launch the AXE® web accessibility evaluation tool.
All trademarks or registered trademarks are property of their respective owners. AXE® Terms of Use
The overall accessibility level of your application depends on the RangeSlider features used.
Backend API
$(() => { $('#range-slider-simple').dxRangeSlider({ min: 0, max: 100, start: 20, end: 60, }); $('#range-slider-with-label').dxRangeSlider({ min: 0, max: 100, start: 35, end: 65, label: { visible: true, format(value) { return `${value}%`; }, position: 'top', }, }); $('#range-slider-with-tooltip').dxRangeSlider({ min: 0, max: 100, start: 15, end: 65, tooltip: { enabled: true, format(value) { return `${value}%`; }, showMode: 'always', position: 'bottom', }, }); $('#range-slider-with-hide-range').dxRangeSlider({ min: 0, max: 100, start: 20, end: 80, showRange: false, }); $('#range-slider-with-step').dxRangeSlider({ min: 0, max: 100, start: 20, end: 70, step: 10, tooltip: { enabled: true, }, }); $('#range-slider-disabled').dxRangeSlider({ min: 0, max: 100, start: 25, end: 75, disabled: true, }); const onHandleMoveRangeSlider = $('#slider-on-handle-move').dxRangeSlider({ min: 0, max: 100, start: 10, end: 90, onValueChanged({ value, start, end }) { onHandleReleaseRangeSlider.option('value', value); startValue.option('value', start); endValue.option('value', end); }, }).dxRangeSlider('instance'); const onHandleReleaseRangeSlider = $('#slider-on-handle-release').dxRangeSlider({ min: 0, max: 100, start: 10, end: 90, valueChangeMode: 'onHandleRelease', onValueChanged({ value, start, end }) { onHandleMoveRangeSlider.option('value', value); startValue.option('value', start); endValue.option('value', end); }, }).dxRangeSlider('instance'); const startValue = $('#start-value').dxNumberBox({ value: 10, min: 0, max: 100, showSpinButtons: true, inputAttr: { 'aria-label': 'Start Value' }, onValueChanged({ value }) { onHandleMoveRangeSlider.option('start', value); onHandleReleaseRangeSlider.option('start', value); }, }).dxNumberBox('instance'); const endValue = $('#end-value').dxNumberBox({ value: 90, min: 0, max: 100, showSpinButtons: true, inputAttr: { 'aria-label': 'End Value' }, onValueChanged({ value }) { onHandleMoveRangeSlider.option('end', value); onHandleReleaseRangeSlider.option('end', value); }, }).dxNumberBox('instance'); });
<!DOCTYPE html> <html xmlns="http://www.w3.org/1999/xhtml" lang="en"> <head> <title>DevExtreme Demo</title> <meta http-equiv="X-UA-Compatible" content="IE=edge" /> <meta http-equiv="Content-Type" content="text/html; charset=utf-8" /> <meta name="viewport" content="width=device-width, initial-scale=1.0, maximum-scale=5.0" /> <script src="https://ajax.googleapis.com/ajax/libs/jquery/3.5.1/jquery.min.js"></script> <script>window.jQuery || document.write(decodeURIComponent('%3Cscript src="js/jquery.min.js"%3E%3C/script%3E'))</script> <link rel="stylesheet" type="text/css" href="https://cdn3.devexpress.com/jslib/25.1.3/css/dx.light.css" /> <script src="js/dx.all.js"></script> <link rel="stylesheet" type="text/css" href="styles.css" /> <script src="index.js"></script> </head> <body class="dx-viewport"> <div class="demo-container"> <div class="form"> <div class="dx-fieldset"> <div class="dx-field"> <div class="dx-field-label">Default mode</div> <div class="dx-field-value"> <div id="range-slider-simple"></div> </div> </div> <div class="dx-field custom-height-slider"> <div class="dx-field-label">With labels</div> <div class="dx-field-value"> <div id="range-slider-with-label"></div> </div> </div> <div class="dx-field custom-height-slider"> <div class="dx-field-label">With tooltips</div> <div class="dx-field-value"> <div id="range-slider-with-tooltip"></div> </div> </div> <div class="dx-field"> <div class="dx-field-label">Without range highlighting</div> <div class="dx-field-value"> <div id="range-slider-with-hide-range"></div> </div> </div> <div class="dx-field"> <div class="dx-field-label">With discrete step</div> <div class="dx-field-value"> <div id="range-slider-with-step"></div> </div> </div> <div class="dx-field"> <div class="dx-field-label">Disabled</div> <div class="dx-field-value"> <div id="range-slider-disabled"></div> </div> </div> </div> <div class="dx-fieldset"> <div class="dx-fieldset-header">Process Value Changes</div> <div class="dx-field"> <div class="dx-field-label">On handle movement</div> <div class="dx-field-value"> <div id="slider-on-handle-move"></div> </div> </div> <div class="dx-field"> <div class="dx-field-label">On handle release</div> <div class="dx-field-value"> <div id="slider-on-handle-release"></div> </div> </div> <div class="dx-field"> <div class="dx-field-label">Start value</div> <div class="dx-field-value"> <div id="start-value"></div> </div> </div> <div class="dx-field"> <div class="dx-field-label">End value</div> <div class="dx-field-value"> <div id="end-value"></div> </div> </div> </div> </div> </div> </body> </html>
.custom-height-slider { height: 75px; } .dx-field > .dx-rangeslider { flex: 1; }

Create a JavaScript RangeSlider

To create a JavaScript RangeSlider, declare it in markup and specify the following four properties:

  • start and end
    Specify the selected interval.

  • min and max
    Limit the range of accepted values.

You can see the resulting JavaScript RangeSlider in the Default mode section of this demo.

Customize JavaScript RangeSlider Appearance

The JavaScript RangeSlider can display labels for the min and max values. To configure the labels, use the label object. In this object, set the visible property to true to display the labels. You can also specify the position and format properties.

The JavaScript RangeSlider can also display a tooltip for slider handles. To display tooltips, you need to configure the tooltip object:

  • Set the enabled property to true to display tooltips.

  • Specify the tooltip position.

  • Specify the format property.

  • Assign 'onHover' or 'always' to the showMode property to change how the component shows tooltips.

Use the showRange property to specify if the selected range should be highlighted. You can also use the step property to specify the value change step for the JavaScript RangeSlider.

If you want to disable the JavaScript RangeSlider, set the disabled property to true.

Handle the Value Change Event

Specify the onValueChanged function to handle the value change. In this demo, the NumberBox components and the JavaScript RangeSlider use this property to exchange values.

The valueChangeMode property allows you to choose when to change the JavaScript RangeSlider value and supports the onHandleMove and onHandleRelease modes. You can see the property's effect in the Process Value Changes section. The first JavaScript RangeSlider changes its value every time a user slides the handle. The second JavaScript RangeSlider changes its value only when the handle is released. These JavaScript RangeSlider values are synchronized.

DevExtreme v26.1 is now available.

Explore our newest features/capabilities and share your thoughts with us.

Your search did not match any results.

Angular Range Slider

The RangeSlider component allows users to choose a range of numeric values. This demo shows how you can create and configure a RangeSlider.

DevExtreme Accessibility Compliance
DevExtreme component libraries meet a variety of WCAG and Section 508 compliance standards. To assess this demo's accessibility level, click the Run AXE® Validation button to launch the AXE® web accessibility evaluation tool.
All trademarks or registered trademarks are property of their respective owners. AXE® Terms of Use
The overall accessibility level of your application depends on the RangeSlider features used.
Backend API
<div class="form"> <div class="dx-fieldset"> <div class="dx-field"> <div class="dx-field-label">Default mode</div> <div class="dx-field-value"> <dx-range-slider [min]="0" [max]="100" [start]="20" [end]="60" ></dx-range-slider> </div> </div> <div class="dx-field custom-height-slider"> <div class="dx-field-label">With labels</div> <div class="dx-field-value"> <dx-range-slider [min]="0" [max]="100" [start]="35" [end]="65" [label]="label" ></dx-range-slider> </div> </div> <div class="dx-field custom-height-slider"> <div class="dx-field-label">With tooltips</div> <div class="dx-field-value"> <dx-range-slider [min]="0" [max]="100" [start]="15" [end]="65" [tooltip]="tooltip" ></dx-range-slider> </div> </div> <div class="dx-field"> <div class="dx-field-label">Without range highlighting</div> <div class="dx-field-value"> <dx-range-slider [min]="0" [max]="100" [start]="20" [end]="80" [showRange]="false" ></dx-range-slider> </div> </div> <div class="dx-field"> <div class="dx-field-label">With discrete step</div> <div class="dx-field-value"> <dx-range-slider [min]="0" [max]="100" [start]="20" [end]="70" [step]="10" [tooltip]="tooltipEnabled" ></dx-range-slider> </div> </div> <div class="dx-field"> <div class="dx-field-label">Disabled</div> <div class="dx-field-value"> <dx-range-slider [min]="0" [max]="100" [start]="25" [end]="75" [disabled]="true" ></dx-range-slider> </div> </div> </div> <div class="dx-fieldset"> <div class="dx-fieldset-header">Process Value Changes</div> <div class="dx-field"> <div class="dx-field-label">On handle movement</div> <div class="dx-field-value"> <dx-range-slider [(start)]="start" [(end)]="end" [min]="0" [max]="100" ></dx-range-slider> </div> </div> <div class="dx-field"> <div class="dx-field-label">On handle release</div> <div class="dx-field-value"> <dx-range-slider [(start)]="start" [(end)]="end" [min]="0" [max]="100" valueChangeMode="onHandleRelease" ></dx-range-slider> </div> </div> <div class="dx-field"> <div class="dx-field-label">Start value</div> <div class="dx-field-value"> <dx-number-box [(value)]="start" [min]="0" [max]="100" [showSpinButtons]="true" [inputAttr]="{ 'aria-label': 'Start Value' }" ></dx-number-box> </div> </div> <div class="dx-field"> <div class="dx-field-label">End value</div> <div class="dx-field-value"> <dx-number-box [(value)]="end" [min]="0" [max]="100" [showSpinButtons]="true" [inputAttr]="{ 'aria-label': 'End Value' }" ></dx-number-box> </div> </div> </div> </div>
import { bootstrapApplication } from '@angular/platform-browser'; import { Component, enableProdMode, provideZoneChangeDetection } from '@angular/core'; import { DxRangeSliderModule, DxNumberBoxModule } from 'devextreme-angular'; if (!/localhost/.test(document.location.host)) { enableProdMode(); } let modulePrefix = ''; // @ts-ignore if (window && window.config?.packageConfigPaths) { modulePrefix = '/app'; } @Component({ selector: 'demo-app', templateUrl: `app/app.component.html`, styleUrls: [`app/app.component.css`], imports: [ DxRangeSliderModule, DxNumberBoxModule, ], }) export class AppComponent { start = 10; end = 90; format = (value: unknown) => `${value}%`; label = { visible: true, format: (value: unknown) => this.format(value), position: 'top', }; tooltip = { enabled: true, format: (value: unknown) => this.format(value), showMode: 'always', position: 'bottom', }; tooltipEnabled = { enabled: true, }; } bootstrapApplication(AppComponent, { providers: [ provideZoneChangeDetection({ eventCoalescing: true, runCoalescing: true }), ], });
::ng-deep .custom-height-slider { height: 75px; } ::ng-deep .dx-field > .dx-rangeslider { flex: 1; }
// In real applications, you should not transpile code in the browser. // You can see how to create your own application with Angular and DevExtreme here: // https://js.devexpress.com/Documentation/Guide/Angular_Components/Getting_Started/Create_a_DevExtreme_Application/ const componentNames = [ 'accordion', 'action-sheet', 'autocomplete', 'bar-gauge', 'box', 'bullet', 'button-group', 'button', 'calendar', 'card-view', 'chart', 'chat', 'check-box', 'circular-gauge', 'color-box', 'context-menu', 'data-grid', 'date-box', 'date-range-box', 'defer-rendering', 'diagram', 'draggable', 'drawer', 'drop-down-box', 'drop-down-button', 'file-manager', 'file-uploader', 'filter-builder', 'form', 'funnel', 'gallery', 'gantt', 'html-editor', 'linear-gauge', 'list', 'load-indicator', 'load-panel', 'lookup', 'map', 'menu', 'multi-view', 'nested', 'number-box', 'pagination', 'pie-chart', 'pivot-grid-field-chooser', 'pivot-grid', 'polar-chart', 'popover', 'popup', 'progress-bar', 'radio-group', 'range-selector', 'range-slider', 'recurrence-editor', 'resizable', 'responsive-box', 'sankey', 'scheduler', 'scroll-view', 'select-box', 'slider', 'sortable', 'sparkline', 'speech-to-text', 'speed-dial-action', 'splitter', 'stepper', 'switch', 'tab-panel', 'tabs', 'tag-box', 'text-area', 'text-box', 'tile-view', 'toast', 'toolbar', 'tooltip', 'tree-list', 'tree-map', 'tree-view', 'validation-group', 'validation-summary', 'validator', 'vector-map', ]; window.exports = window.exports || {}; window.config = { transpiler: false, meta: { '*.ts': { loader: 'demo-ts-loader', }, 'typescript': { 'exports': 'ts', }, 'anti-forgery': { loader: 'demo-ts-loader', }, 'devextreme/time_zone_utils.js': { 'esModule': true, }, 'devextreme/localization.js': { 'esModule': true, }, 'devextreme/viz/palette.js': { 'esModule': true, }, '@angular/platform-browser-dynamic': { 'esModule': true, }, '@angular/platform-browser': { 'esModule': true, }, '@angular/core': { 'esModule': true, }, '@angular/common': { 'esModule': true, }, '@angular/common/http': { 'esModule': true, }, '@angular/animations': { 'esModule': true, }, '@angular/forms': { 'esModule': true, }, 'openai': { 'esModule': true, }, 'zod': { 'esModule': true, }, 'zod-to-json-schema': { 'esModule': true, }, }, paths: { 'project:': '../../../../', 'npm:': 'https://cdn.jsdelivr.net/npm/', 'bundles:': '../../../../bundles/', 'externals:': '../../../../bundles/externals/', 'anti-forgery:': '../../../../shared/anti-forgery/', }, map: { 'anti-forgery': 'anti-forgery:fetch-override.js', 'demo-ts-loader': 'project:utils/demo-ts-loader.js', 'demo-ts-shared': 'project:utils/demo-ts-shared.js', 'typescript': 'npm:typescript@4.2.4/lib/typescript.js', 'jszip': 'npm:jszip@3.10.1/dist/jszip.min.js', /* @angular */ '@angular/compiler': 'bundles:@angular/compiler.umd.js', '@angular/platform-browser-dynamic': 'bundles:@angular/platform-browser-dynamic.umd.js', '@angular/core': 'bundles:@angular/core.umd.js', '@angular/core/primitives/signals': 'bundles:@angular/core.primitives.signals.umd.js', '@angular/core/primitives/di': 'bundles:@angular/core.primitives.di.umd.js', '@angular/common': 'bundles:@angular/common.umd.js', '@angular/common/http': 'bundles:@angular/common-http.umd.js', '@angular/platform-browser': 'bundles:@angular/platform-browser.umd.js', '@angular/platform-browser/animations': 'bundles:@angular/platform-browser.umd.js', '@angular/forms': 'bundles:@angular/forms.umd.js', /* devextreme */ 'devextreme': 'npm:devextreme@link:../../packages/devextreme/artifacts/npm/devextreme/cjs', 'devextreme-quill': 'npm:devextreme-quill@1.7.10/dist/dx-quill.min.js', 'devexpress-diagram': 'npm:devexpress-diagram@2.2.29', 'devexpress-gantt': 'npm:devexpress-gantt@4.1.69', /* devextreme-angular umd maps */ 'devextreme-angular': 'bundles:devextreme-angular/devextreme-angular.umd.js', 'devextreme-angular/common/ai-integration': 'bundles:devextreme-angular/devextreme-angular-common-ai-integration.umd.js', 'devextreme-angular/core': 'bundles:devextreme-angular/devextreme-angular-core.umd.js', 'devextreme-angular/common/charts': 'bundles:devextreme-angular/devextreme-angular-common-charts.umd.js', 'devextreme-angular/common/core/animation': 'bundles:devextreme-angular/devextreme-angular-common-core-animation.umd.js', 'devextreme-angular/common/core/environment': 'bundles:devextreme-angular/devextreme-angular-common-core-environment.umd.js', 'devextreme-angular/common/core/events': 'bundles:devextreme-angular/devextreme-angular-common-core-events.umd.js', 'devextreme-angular/common/core/localization': 'bundles:devextreme-angular/devextreme-angular-common-core-localization.umd.js', 'devextreme-angular/common/core': 'bundles:devextreme-angular/devextreme-angular-common-core.umd.js', 'devextreme-angular/common/data/custom-store': 'bundles:devextreme-angular/devextreme-angular-common-data-custom-store.umd.js', 'devextreme-angular/common/data': 'bundles:devextreme-angular/devextreme-angular-common-data.umd.js', 'devextreme-angular/common/export/excel': 'bundles:devextreme-angular/devextreme-angular-common-export-excel.umd.js', 'devextreme-angular/common/export/pdf': 'bundles:devextreme-angular/devextreme-angular-common-export-pdf.umd.js', 'devextreme-angular/common/export': 'bundles:devextreme-angular/devextreme-angular-common-export.umd.js', 'devextreme-angular/common/grids': 'bundles:devextreme-angular/devextreme-angular-common-grids.umd.js', 'devextreme-angular/common': 'bundles:devextreme-angular/devextreme-angular-common.umd.js', 'devextreme-angular/http': 'bundles:devextreme-angular/devextreme-angular-http.umd.js', 'devextreme-angular/core/tokens': 'bundles:devextreme-angular/devextreme-angular-core-tokens.umd.js', ...componentNames.reduce((acc, name) => { acc[`devextreme-angular/ui/${name}`] = `bundles:devextreme-angular/devextreme-angular-ui-${name}.umd.js`; acc[`devextreme-angular/ui/${name}/nested`] = `bundles:devextreme-angular/devextreme-angular-ui-${name}-nested.umd.js`; return acc; }, {}), 'zod': 'externals:zod.bundle.js', 'zod-to-json-schema': 'externals:zod-to-json-schema.bundle.js', 'tslib': 'npm:tslib/tslib.js', 'rxjs': 'npm:rxjs@7.5.3/dist/bundles/rxjs.umd.js', 'rxjs/operators': 'npm:rxjs@7.5.3/dist/cjs/operators/index.js', 'rrule': 'npm:rrule@2.6.4/dist/es5/rrule.js', 'luxon': 'npm:luxon@3.4.4/build/global/luxon.min.js', 'es6-object-assign': 'npm:es6-object-assign', 'inferno': 'npm:inferno@8.2.3/dist/inferno.min.js', 'inferno-compat': 'npm:inferno-compat/dist/inferno-compat.min.js', 'inferno-create-element': 'npm:inferno-create-element@8.2.3/dist/inferno-create-element.min.js', 'inferno-dom': 'npm:inferno-dom/dist/inferno-dom.min.js', 'inferno-hydrate': 'npm:inferno-hydrate/dist/inferno-hydrate.min.js', 'inferno-clone-vnode': 'npm:inferno-clone-vnode/dist/inferno-clone-vnode.min.js', 'inferno-create-class': 'npm:inferno-create-class/dist/inferno-create-class.min.js', 'inferno-extras': 'npm:inferno-extras/dist/inferno-extras.min.js', '@preact/signals-core': 'npm:@preact/signals-core@1.14.1/dist/signals-core.min.js', // Prettier 'prettier/standalone': 'npm:prettier@2.8.8/standalone.js', 'prettier/parser-html': 'npm:prettier@2.8.8/parser-html.js', 'zone.js': 'npm:zone.js@0.16.2/bundles/zone.umd.js', }, packages: { 'app': { main: './app.component.ts', defaultExtension: 'ts', }, 'devextreme': { defaultExtension: 'js', }, 'devextreme/events/utils': { main: 'index', }, 'devextreme/common/core/events/utils': { main: 'index', }, 'devextreme/events': { main: 'index', }, 'es6-object-assign': { main: './index.js', defaultExtension: 'js', }, 'rxjs': { defaultExtension: 'js', }, 'rxjs/operators': { defaultExtension: 'js', }, }, packageConfigPaths: [ 'npm:@devextreme/*/package.json', 'npm:rxjs@7.5.3/package.json', 'npm:rxjs@7.5.3/operators/package.json', 'npm:devexpress-diagram@2.2.29/package.json', 'npm:devexpress-gantt@4.1.69/package.json', ], }; window.process = { env: { NODE_ENV: 'production', }, }; System.config(window.config); // eslint-disable-next-line no-console // System.import('@angular/compiler').catch(console.error.bind(console)); // eslint-disable-next-line const useTgzInCSB = ['openai']; let packagesInfo = { "zod": { "version": "3.24.4" }, "zod-to-json-schema": { "version": "3.24.6" }, "@angular/core": { "version": "22.0.2" }, "core-js": { "version": "2.6.12" }, "typescript": { "version": "6.0.3" }, "zone.js": { "version": "0.16.2" } };
<!DOCTYPE html> <html xmlns="http://www.w3.org/1999/xhtml" lang="en"> <head> <title>DevExtreme Demo</title> <meta http-equiv="X-UA-Compatible" content="IE=edge" /> <meta http-equiv="Content-Type" content="text/html; charset=utf-8" /> <meta name="viewport" content="width=device-width, initial-scale=1.0, maximum-scale=5.0" /> <link rel="stylesheet" type="text/css" href="https://cdn3.devexpress.com/jslib/26.1.3/css/dx.light.css" /> <script src="https://cdn.jsdelivr.net/npm/core-js@2.6.12/client/shim.min.js"></script> <script src="https://cdn.jsdelivr.net/npm/zone.js@0.16.2/bundles/zone.umd.js"></script> <script src="https://cdn.jsdelivr.net/npm/reflect-metadata@0.1.13/Reflect.js"></script> <script src="https://cdn.jsdelivr.net/npm/systemjs@0.21.3/dist/system.js"></script> <script src="config.js"></script> <script> System.import("app").catch(console.error.bind(console)); </script> </head> <body class="dx-viewport"> <div class="demo-container"> <demo-app>Loading...</demo-app> </div> </body> </html>

Create a RangeSlider

To create a RangeSlider, declare it in markup and specify the following four properties:

  • start and end
    Specify the selected interval.

  • min and max
    Limit the range of accepted values.

You can see the resulting RangeSlider in the Default mode section of this demo.

Customize RangeSlider Appearance

The RangeSlider can display labels for the min and max values. To configure the labels, use the label object. In this object, set the visible property to true to display the labels. You can also specify the position and format properties.

The RangeSlider can also display a tooltip for slider handles. To display tooltips, you need to configure the tooltip object:

  • Set the enabled property to true to display tooltips.

  • Specify the tooltip position.

  • Specify the format property.

  • Assign 'onHover' or 'always' to the showMode property to change how the component shows tooltips.

Use the showRange property to specify if the selected range should be highlighted. You can also use the step property to specify the value change step for the RangeSlider.

If you want to disable the RangeSlider, set the disabled property to true.

Handle the Value Change Event

To handle value changes, use two-way binding to bind the value properties of NumberBox components to the start and end properties of the RangeSlider.

The valueChangeMode property allows you to choose when to change the RangeSlider value and supports the onHandleMove and onHandleRelease modes. You can see the property's effect in the Process Value Changes section. The first RangeSlider changes its value every time a user slides the handle. The second RangeSlider changes its value only when the handle is released. These RangeSlider values are synchronized.

If you have technical questions, please create a support ticket in the DevExpress Support Center.
import React, { useCallback, useState } from 'react';
import RangeSlider, { Tooltip, Label, RangeSliderTypes } from 'devextreme-react/range-slider';
import NumberBox, { NumberBoxTypes } from 'devextreme-react/number-box';
const defaultValues = {
defaultMode: [20, 60],
labels: [35, 65],
tooltips: [15, 65],
withoutRangeHighlighting: [20, 80],
discreteStep: [20, 70],
disabled: [25, 75],
};
const startValueLabel = { 'aria-label': 'Start Value' };
const endValueLabel = { 'aria-label': 'End Value' };
function App() {
const [startValue, setStartValue] = useState(10);
const [endValue, setEndValue] = useState(90);
const onRangeChanged = useCallback((data: RangeSliderTypes.ValueChangedEvent) => {
setStartValue(data.start);
setEndValue(data.end);
}, [setStartValue, setEndValue]);
const onStartChanged = useCallback((data: NumberBoxTypes.ValueChangedEvent) => {
setStartValue(data.value);
}, [setStartValue]);
const onEndChanged = useCallback((data: NumberBoxTypes.ValueChangedEvent) => {
setEndValue(data.value);
}, [setEndValue]);
return (
<div className="form">
<div className="dx-fieldset">
<div className="dx-field">
<div className="dx-field-label">Default mode</div>
<div className="dx-field-value">
<RangeSlider min={0} max={100} defaultValue={defaultValues.defaultMode} />
</div>
</div>
<div className="dx-field custom-height-slider">
<div className="dx-field-label">With labels</div>
<div className="dx-field-value">
<RangeSlider min={0} max={100} defaultValue={defaultValues.labels}>
<Label visible={true} format={format} position="top" />
</RangeSlider>
</div>
</div>
<div className="dx-field custom-height-slider">
<div className="dx-field-label">With tooltips</div>
<div className="dx-field-value">
<RangeSlider min={0} max={100} defaultValue={defaultValues.tooltips}>
<Tooltip enabled={true} format={format} showMode="always" position="bottom" />
</RangeSlider>
</div>
</div>
<div className="dx-field">
<div className="dx-field-label">Without range highlighting</div>
<div className="dx-field-value">
<RangeSlider
min={0}
max={100}
defaultValue={defaultValues.withoutRangeHighlighting}
showRange={false} />
</div>
</div>
<div className="dx-field">
<div className="dx-field-label">With discrete step</div>
<div className="dx-field-value">
<RangeSlider min={0} max={100} defaultValue={defaultValues.discreteStep} step={10}>
<Tooltip enabled={true} />
</RangeSlider>
</div>
</div>
<div className="dx-field">
<div className="dx-field-label">Disabled</div>
<div className="dx-field-value">
<RangeSlider
min={0}
max={100}
defaultValue={defaultValues.disabled}
disabled={true} />
</div>
</div>
</div>
<div className="dx-fieldset">
<div className="dx-fieldset-header">Process Value Changes</div>
<div className="dx-field">
<div className="dx-field-label">On handle movement</div>
<div className="dx-field-value">
<RangeSlider
min={0}
max={100}
start={startValue}
end={endValue}
onValueChanged={onRangeChanged} />
</div>
</div>
<div className="dx-field">
<div className="dx-field-label">On handle release</div>
<div className="dx-field-value">
<RangeSlider
min={0}
max={100}
start={startValue}
end={endValue}
valueChangeMode="onHandleRelease"
onValueChanged={onRangeChanged} />
</div>
</div>
<div className="dx-field">
<div className="dx-field-label">Start value</div>
<div className="dx-field-value">
<NumberBox
value={startValue}
min={0}
max={100}
showSpinButtons={true}
inputAttr={startValueLabel}
onValueChanged={onStartChanged} />
</div>
</div>
<div className="dx-field">
<div className="dx-field-label">End value</div>
<div className="dx-field-value">
<NumberBox
value={endValue}
min={0}
max={100}
showSpinButtons={true}
inputAttr={endValueLabel}
onValueChanged={onEndChanged} />
</div>
</div>
</div>
</div>
);
}
function format(value) {
return `${value}%`;
}
export default App;
xxxxxxxxxx
import React, { useCallback, useState } from 'react';
import RangeSlider, { Tooltip, Label } from 'devextreme-react/range-slider';
import NumberBox from 'devextreme-react/number-box';
const defaultValues = {
defaultMode: [20, 60],
labels: [35, 65],
tooltips: [15, 65],
withoutRangeHighlighting: [20, 80],
discreteStep: [20, 70],
disabled: [25, 75],
};
const startValueLabel = { 'aria-label': 'Start Value' };
const endValueLabel = { 'aria-label': 'End Value' };
function App() {
const [startValue, setStartValue] = useState(10);
const [endValue, setEndValue] = useState(90);
const onRangeChanged = useCallback(
(data) => {
setStartValue(data.start);
setEndValue(data.end);
},
[setStartValue, setEndValue],
);
const onStartChanged = useCallback(
(data) => {
setStartValue(data.value);
},
[setStartValue],
);
const onEndChanged = useCallback(
(data) => {
setEndValue(data.value);
},
[setEndValue],
);
return (
<div className="form">
<div className="dx-fieldset">
<div className="dx-field">
<div className="dx-field-label">Default mode</div>
<div className="dx-field-value">
<RangeSlider
min={0}
max={100}
defaultValue={defaultValues.defaultMode}
/>
</div>
</div>
<div className="dx-field custom-height-slider">
<div className="dx-field-label">With labels</div>
<div className="dx-field-value">
<RangeSlider
min={0}
max={100}
defaultValue={defaultValues.labels}
>
<Label
visible={true}
format={format}
position="top"
/>
</RangeSlider>
</div>
</div>
<div className="dx-field custom-height-slider">
<div className="dx-field-label">With tooltips</div>
<div className="dx-field-value">
<RangeSlider
min={0}
max={100}
defaultValue={defaultValues.tooltips}
>
<Tooltip
enabled={true}
format={format}
showMode="always"
position="bottom"
/>
</RangeSlider>
</div>
</div>
<div className="dx-field">
<div className="dx-field-label">Without range highlighting</div>
<div className="dx-field-value">
<RangeSlider
min={0}
max={100}
defaultValue={defaultValues.withoutRangeHighlighting}
showRange={false}
/>
</div>
</div>
<div className="dx-field">
<div className="dx-field-label">With discrete step</div>
<div className="dx-field-value">
<RangeSlider
min={0}
max={100}
defaultValue={defaultValues.discreteStep}
step={10}
>
<Tooltip enabled={true} />
</RangeSlider>
</div>
</div>
<div className="dx-field">
<div className="dx-field-label">Disabled</div>
<div className="dx-field-value">
<RangeSlider
min={0}
max={100}
defaultValue={defaultValues.disabled}
disabled={true}
/>
</div>
</div>
</div>
<div className="dx-fieldset">
<div className="dx-fieldset-header">Process Value Changes</div>
<div className="dx-field">
<div className="dx-field-label">On handle movement</div>
<div className="dx-field-value">
<RangeSlider
min={0}
max={100}
start={startValue}
end={endValue}
onValueChanged={onRangeChanged}
/>
</div>
</div>
<div className="dx-field">
<div className="dx-field-label">On handle release</div>
<div className="dx-field-value">
<RangeSlider
min={0}
max={100}
start={startValue}
end={endValue}
valueChangeMode="onHandleRelease"
onValueChanged={onRangeChanged}
/>
</div>
</div>
<div className="dx-field">
<div className="dx-field-label">Start value</div>
<div className="dx-field-value">
<NumberBox
value={startValue}
min={0}
max={100}
showSpinButtons={true}
inputAttr={startValueLabel}
onValueChanged={onStartChanged}
/>
</div>
</div>
<div className="dx-field">
<div className="dx-field-label">End value</div>
<div className="dx-field-value">
<NumberBox
value={endValue}
min={0}
max={100}
showSpinButtons={true}
inputAttr={endValueLabel}
onValueChanged={onEndChanged}
/>
</div>
</div>
</div>
</div>
);
}
function format(value) {
return `${value}%`;
}
export default App;
xxxxxxxxxx
import React from 'react';
import ReactDOM from 'react-dom';
import App from './App.tsx';
ReactDOM.render(
<App />,
document.getElementById('app'),
);
xxxxxxxxxx
window.exports = window.exports || {};
window.config = {
transpiler: 'ts',
typescriptOptions: {
module: 'system',
emitDecoratorMetadata: true,
experimentalDecorators: true,
jsx: 'react',
},
meta: {
'react': {
'esModule': true,
},
'typescript': {
'exports': 'ts',
},
'devextreme/time_zone_utils.js': {
'esModule': true,
},
'devextreme/localization.js': {
'esModule': true,
},
'devextreme/viz/palette.js': {
'esModule': true,
},
'openai': {
'esModule': true,
},
},
paths: {
'npm:': 'https://unpkg.com/',
'bundles:': 'bundles/',
'externals:': 'bundles/externals/',
},
defaultExtension: 'js',
map: {
'ts': 'npm:plugin-typescript@8.0.0/lib/plugin.js',
'typescript': 'npm:typescript@4.2.4/lib/typescript.js',
'jszip': 'npm:jszip@3.10.1/dist/jszip.min.js',
'react': 'npm:react@17.0.2/umd/react.development.js',
'react-dom': 'npm:react-dom@17.0.2/umd/react-dom.development.js',
'prop-types': 'npm:prop-types/prop-types.js',
'rrule': 'npm:rrule@2.6.4/dist/es5/rrule.js',
'luxon': 'npm:luxon@3.4.4/build/global/luxon.min.js',
'es6-object-assign': 'npm:es6-object-assign',
'devextreme': 'npm:devextreme@24.2.6/cjs',
'devextreme-react': 'npm:devextreme-react@24.2.6/cjs',
'devextreme-quill': 'npm:devextreme-quill@1.7.1/dist/dx-quill.min.js',
'devexpress-diagram': 'npm:devexpress-diagram@2.2.15/dist/dx-diagram.js',
'devexpress-gantt': 'npm:devexpress-gantt@4.1.60/dist/dx-gantt.js',
'@devextreme/runtime': 'npm:@devextreme/runtime@3.0.12',
'inferno': 'npm:inferno@7.4.11/dist/inferno.min.js',
'inferno-compat': 'npm:inferno-compat/dist/inferno-compat.min.js',
'inferno-create-element': 'npm:inferno-create-element@7.4.11/dist/inferno-create-element.min.js',
'inferno-dom': 'npm:inferno-dom/dist/inferno-dom.min.js',
'inferno-hydrate': 'npm:inferno-hydrate/dist/inferno-hydrate.min.js',
'inferno-clone-vnode': 'npm:inferno-clone-vnode/dist/inferno-clone-vnode.min.js',
'inferno-create-class': 'npm:inferno-create-class/dist/inferno-create-class.min.js',
'inferno-extras': 'npm:inferno-extras/dist/inferno-extras.min.js',
'devextreme-cldr-data': 'npm:devextreme-cldr-data@1.0.3',
// SystemJS plugins
'plugin-babel': 'npm:systemjs-plugin-babel@0.0.25/plugin-babel.js',
'systemjs-babel-build': 'npm:systemjs-plugin-babel@0.0.25/systemjs-babel-browser.js',
// Prettier
'prettier/standalone': 'npm:prettier@2.8.8/standalone.js',
'prettier/parser-html': 'npm:prettier@2.8.8/parser-html.js',
},
packages: {
'devextreme': {
defaultExtension: 'js',
},
'devextreme-react': {
main: 'index.js',
},
'devextreme/events/utils': {
main: 'index',
},
'devextreme/localization/messages': {
format: 'json',
defaultExtension: 'json',
},
'devextreme/events': {
main: 'index',
},
'es6-object-assign': {
main: './index.js',
defaultExtension: 'js',
},
},
packageConfigPaths: [
'npm:@devextreme/*/package.json',
'npm:@devextreme/runtime@3.0.12/inferno/package.json',
],
babelOptions: {
sourceMaps: false,
stage0: true,
react: true,
},
};
System.config(window.config);
xxxxxxxxxx
import React from 'react';
import ReactDOM from 'react-dom';
import App from './App.js';
ReactDOM.render(<App />, document.getElementById('app'));
xxxxxxxxxx
<html lang="en">
<head></head>
<body class="dx-viewport">
<div class="demo-container">
<div id="app"></div>
</div>
</body>
</html>
xxxxxxxxxx
.custom-height-slider {
height: 75px;
}
.dx-field > .dx-rangeslider {
flex: 1;
}
Create a RangeSlider
To create a RangeSlider, declare it in markup and specify the following four properties:
You can see the resulting RangeSlider in the Default mode section of this demo.
Customize RangeSlider Appearance
The RangeSlider can display labels for the min and max values. To configure the labels, use the label object. In this object, set the visible property to true
to display the labels. You can also specify the position and format properties.
The RangeSlider can also display a tooltip for slider handles. To display tooltips, you need to configure the tooltip object:
-
Set the enabled property to
true
to display tooltips. -
Specify the tooltip position.
-
Specify the format property.
-
Assign 'onHover' or 'always' to the showMode property to change how the component shows tooltips.
Use the showRange property to specify if the selected range should be highlighted. You can also use the step property to specify the value change step for the RangeSlider.
If you want to disable the RangeSlider, set the disabled property to true
.
Handle the Value Change Event
Specify the onValueChanged function to handle the value change. In this demo, the NumberBox components and the RangeSlider use this property to exchange values.
The valueChangeMode property allows you to choose when to change the RangeSlider value and supports the onHandleMove
and onHandleRelease
modes. You can see the property's effect in the Process Value Changes section. The first RangeSlider changes its value every time a user slides the handle. The second RangeSlider changes its value only when the handle is released. These RangeSlider values are synchronized.

DevExtreme v26.1 is now available.

Explore our newest features/capabilities and share your thoughts with us.

Your search did not match any results.

Vue Range Slider

The RangeSlider component allows users to choose a range of numeric values. This demo shows how you can create and configure a RangeSlider.

DevExtreme Accessibility Compliance
DevExtreme component libraries meet a variety of WCAG and Section 508 compliance standards. To assess this demo's accessibility level, click the Run AXE® Validation button to launch the AXE® web accessibility evaluation tool.
All trademarks or registered trademarks are property of their respective owners. AXE® Terms of Use
The overall accessibility level of your application depends on the RangeSlider features used.
Backend API
<template> <div class="form"> <div class="dx-fieldset"> <div class="dx-field"> <div class="dx-field-label">Default mode</div> <div class="dx-field-value"> <DxRangeSlider :min="0" :max="100" :start="20" :end="60" /> </div> </div> <div class="dx-field custom-height-slider"> <div class="dx-field-label">With labels</div> <div class="dx-field-value"> <DxRangeSlider :min="0" :max="100" :start="35" :end="65" :label="label" /> </div> </div> <div class="dx-field custom-height-slider"> <div class="dx-field-label">With tooltips</div> <div class="dx-field-value"> <DxRangeSlider :min="0" :max="100" :start="15" :end="65" :tooltip="tooltip" /> </div> </div> <div class="dx-field"> <div class="dx-field-label">Without range highlighting</div> <div class="dx-field-value"> <DxRangeSlider :min="0" :max="100" :start="20" :end="80" :show-range="false" /> </div> </div> <div class="dx-field"> <div class="dx-field-label">With discrete step</div> <div class="dx-field-value"> <DxRangeSlider :min="0" :max="100" :start="20" :end="70" :step="10" :tooltip="{enabled: true}" /> </div> </div> <div class="dx-field"> <div class="dx-field-label">Disabled</div> <div class="dx-field-value"> <DxRangeSlider :min="0" :max="100" :start="25" :end="75" :disabled="true" /> </div> </div> </div> <div class="dx-fieldset"> <div class="dx-fieldset-header">Process Value Changes</div> <div class="dx-field"> <div class="dx-field-label">On handle movement</div> <div class="dx-field-value"> <DxRangeSlider v-model:start="start" v-model:end="end" :min="0" :max="100" /> </div> </div> <div class="dx-field"> <div class="dx-field-label">On handle release</div> <div class="dx-field-value"> <DxRangeSlider v-model:start="start" v-model:end="end" :min="0" :max="100" call-value-change="onHandleRelease" /> </div> </div> <div class="dx-field"> <div class="dx-field-label">Start value</div> <div class="dx-field-value"> <DxNumberBox v-model:value="start" :min="0" :max="100" :show-spin-buttons="true" :input-attr="{ 'aria-label': 'Start Value' }" /> </div> </div> <div class="dx-field"> <div class="dx-field-label">End value</div> <div class="dx-field-value"> <DxNumberBox v-model:value="end" :min="0" :max="100" :show-spin-buttons="true" :input-attr="{ 'aria-label': 'End Value' }" /> </div> </div> </div> </div> </template> <script setup lang="ts"> import { ref } from 'vue'; import DxRangeSlider from 'devextreme-vue/range-slider'; import DxNumberBox from 'devextreme-vue/number-box'; const start = ref(10); const end = ref(90); const format = (value: number) => `${value}%`; const label = { visible: true, format, position: 'top', }; const tooltip = { enabled: true, format, showMode: 'always', position: 'bottom', }; </script>
window.exports = window.exports || {}; window.config = { transpiler: false, meta: { '*.vue': { loader: 'vue-loader', }, '*.ts': { loader: 'demo-ts-loader', }, '*.svg': { loader: 'svg-loader', }, 'typescript': { 'exports': 'ts', }, 'vue': { format: 'global', exports: 'Vue', esModule: true, }, 'vuex': { format: 'global', exports: 'Vuex', esModule: true, }, 'devextreme/time_zone_utils.js': { 'esModule': true, }, 'devextreme/localization.js': { 'esModule': true, }, 'devextreme/viz/palette.js': { 'esModule': true, }, 'openai': { 'esModule': true, }, 'zod': { 'esModule': true, }, 'zod-to-json-schema': { 'esModule': true, }, 'anti-forgery': { loader: 'demo-ts-loader', }, }, paths: { 'project:': '../../../../', 'npm:': 'https://cdn.jsdelivr.net/npm/', 'bundles:': '../../../../bundles/', 'externals:': '../../../../bundles/externals/', 'anti-forgery:': '../../../../shared/anti-forgery/', }, map: { 'anti-forgery': 'anti-forgery:fetch-override.js', 'vue': 'npm:vue@3.5.32/dist/vue.global.js', '@vue/shared': 'npm:@vue/shared@3.4.27/dist/shared.cjs.prod.js', 'vue-loader': 'project:utils/demo-vue-loader.js', 'dx-systemjs-vue-browser': 'npm:dx-systemjs-vue-browser@1.1.2/index.js', 'demo-ts-loader': 'project:utils/demo-ts-loader.js', 'demo-ts-shared': 'project:utils/demo-ts-shared.js', 'typescript': 'npm:typescript@4.2.4/lib/typescript.js', 'jszip': 'npm:jszip@3.10.1/dist/jszip.min.js', 'svg-loader': 'project:utils/svg-loader.js', 'mitt': 'npm:mitt/dist/mitt.umd.js', 'rrule': 'npm:rrule@2.6.4/dist/es5/rrule.js', 'luxon': 'npm:luxon@3.4.4/build/global/luxon.min.js', 'es6-object-assign': 'npm:es6-object-assign', 'devextreme': 'npm:devextreme@link:../../packages/devextreme/artifacts/npm/devextreme/cjs', 'devextreme-vue': 'npm:devextreme-vue@link:../../packages/devextreme-vue/npm/cjs', 'zod': 'externals:zod.bundle.js', 'zod-to-json-schema': 'externals:zod-to-json-schema.bundle.js', 'devextreme-quill': 'npm:devextreme-quill@1.7.10/dist/dx-quill.min.js', 'devexpress-diagram': 'npm:devexpress-diagram@2.2.29/dist/dx-diagram.js', 'devexpress-gantt': 'npm:devexpress-gantt@4.1.69/dist/dx-gantt.js', 'inferno': 'npm:inferno@8.2.3/dist/inferno.min.js', 'inferno-compat': 'npm:inferno-compat/dist/inferno-compat.min.js', 'inferno-create-element': 'npm:inferno-create-element@8.2.3/dist/inferno-create-element.min.js', 'inferno-dom': 'npm:inferno-dom/dist/inferno-dom.min.js', 'inferno-hydrate': 'npm:inferno-hydrate/dist/inferno-hydrate.min.js', 'inferno-clone-vnode': 'npm:inferno-clone-vnode/dist/inferno-clone-vnode.min.js', 'inferno-create-class': 'npm:inferno-create-class/dist/inferno-create-class.min.js', 'inferno-extras': 'npm:inferno-extras/dist/inferno-extras.min.js', '@preact/signals-core': 'npm:@preact/signals-core@1.14.1/dist/signals-core.min.js', // Prettier 'prettier/standalone': 'npm:prettier@2.8.8/standalone.js', 'prettier/parser-html': 'npm:prettier@2.8.8/parser-html.js', }, packages: { 'devextreme-vue': { main: 'index.js', }, 'devextreme-vue/common': { main: 'index.js', }, 'devextreme': { defaultExtension: 'js', }, 'devextreme/events/utils': { main: 'index', }, 'devextreme/common/core/events/utils': { main: 'index', }, 'devextreme/events': { main: 'index', }, 'es6-object-assign': { main: './index.js', defaultExtension: 'js', }, }, packageConfigPaths: [ 'npm:@devextreme/*/package.json', ], }; window.process = { env: { NODE_ENV: 'production', }, }; System.config(window.config); // eslint-disable-next-line const useTgzInCSB = ['openai']; let packagesInfo = { "zod": { "version": "3.24.4" }, "zod-to-json-schema": { "version": "3.24.6" } };
import { createApp } from 'vue'; import App from './App.vue'; createApp(App).mount('#app');
.custom-height-slider { height: 75px; } .dx-field > .dx-rangeslider { flex: 1; }
<!DOCTYPE html> <html lang="en"> <head> <title>DevExtreme Demo</title> <meta http-equiv="X-UA-Compatible" content="IE=edge" /> <meta http-equiv="Content-Type" content="text/html; charset=utf-8" /> <meta name="viewport" content="width=device-width, initial-scale=1.0, maximum-scale=5.0" /> <link rel="stylesheet" type="text/css" href="https://cdn3.devexpress.com/jslib/26.1.3/css/dx.light.css" /> <link rel="stylesheet" type="text/css" href="styles.css" /> <script type="module"> import * as vueCompilerSFC from "https://cdn.jsdelivr.net/npm/@vue/compiler-sfc@3.4.27/dist/compiler-sfc.esm-browser.js"; window.vueCompilerSFC = vueCompilerSFC; </script> <script src="https://cdn.jsdelivr.net/npm/core-js@2.6.12/client/shim.min.js"></script> <script src="https://cdn.jsdelivr.net/npm/systemjs@0.21.3/dist/system.js"></script> <script type="text/javascript" src="config.js"></script> <script type="text/javascript"> System.import("./index.ts"); </script> </head> <body class="dx-viewport"> <div class="demo-container"> <div id="app"> </div> </div> </body> </html>

Create a RangeSlider

To create a RangeSlider, declare it in markup and specify the following four properties:

  • start and end
    Specify the selected interval.

  • min and max
    Limit the range of accepted values.

You can see the resulting RangeSlider in the Default mode section of this demo.

Customize RangeSlider Appearance

The RangeSlider can display labels for the min and max values. To configure the labels, use the label object. In this object, set the visible property to true to display the labels. You can also specify the position and format properties.

The RangeSlider can also display a tooltip for slider handles. To display tooltips, you need to configure the tooltip object:

  • Set the enabled property to true to display tooltips.

  • Specify the tooltip position.

  • Specify the format property.

  • Assign 'onHover' or 'always' to the showMode property to change how the component shows tooltips.

Use the showRange property to specify if the selected range should be highlighted. You can also use the step property to specify the value change step for the RangeSlider.

If you want to disable the RangeSlider, set the disabled property to true.

Handle the Value Change Event

To handle value changes, use two-way binding to bind the value properties of different components. In this demo, you can use the NumberBox or RangeSlider component to change the range because their value properties are bound.

The valueChangeMode property allows you to choose when to change the RangeSlider value and supports the onHandleMove and onHandleRelease modes. You can see the property's effect in the Process Value Changes section. The first RangeSlider changes its value every time a user slides the handle. The second RangeSlider changes its value only when the handle is released. These RangeSlider values are synchronized.